#include <ruby.h>

void init_eigenvalue_eigenvector(VALUE);
void init_interpolation(VALUE);
void init_pseudorandom(VALUE);

static VALUE
rb_with_narray(self)
     VALUE self;
{
#ifdef HAVE_NARRAY_H
  return Qtrue;
#else
  return Qfalse;
#endif
}

void Init_ssl2()
{

  VALUE mSSL2;

#ifdef HAVE_NARRAY_H
  rb_require("narray");
#endif

  mSSL2 = rb_define_module("SSL2");

  rb_define_module_function(mSSL2, "with_narray?", rb_with_narray, 0);

  init_eigenvalue_eigenvector(mSSL2);
  init_interpolation(mSSL2);
  init_pseudorandom(mSSL2);
}
