require "ssl2"

narray = SSL2.with_narray?

dim = 5
if narray then
  a = NArray.sfloat(dim,dim)
  for i in 0..dim-1
    for j in 0..dim-1
      a[j,i] = i-dim
      a[i,j] = dim-1
    end
  end
else
  a = Array.new(dim)
  for i in 0..dim-1
    a[i] = Array.new(dim)
  end
  for i in 0..dim-1
    for j in 0..dim-1
      a[j][i] = i-dim
      a[i][j] = dim-1
    end
  end
end


er,ei,ev = SSL2.eig1(a,0)


i=0
while i<dim
  if ei[i]==0 then
    printf("eigenvalue: %7.4f\n",er[i])
    printf("eigenvector: ")
    for j in 0..dim-1
      if narray then
	printf("%7.4f  ",ev[j,i])
      else
	printf("%7.4f  ",ev[j][i])
      end
    end
    printf("\n")
    i += 1
  else
    printf("eigenvalue:  {%7.4f, %7.4f}\n",er[i],ei[i])
    printf("eigenvector:  ")
    for j in 0..dim-1
      if narray then
	printf("{%7.4f, %7.4f}  ",ev[j,i],ev[j,i+1])
      else
	printf("{%7.4f, %7.4f}  ",ev[j][i],ev[j][i+1])
      end
    end
    printf("\n")
    printf("eigenvalue:  {%7.4f, %7.4f}\n",er[i+1],ei[i+1])
    printf("eigenvector:  ")
    for j in 0..dim-1
      if narray then
	printf("{%7.4f, %7.4f}  ",ev[j,i],-ev[j,i+1])
      else
	printf("{%7.4f, %7.4f}  ",ev[j][i],-ev[j][i+1])
      end
    end
    printf("\n")
    i += 2
  end
end
